/********************************************************************************
 * Copyright (c) 2023 CEA-List
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************/

#include <pybind11/pybind11.h>
#include "aidge/backend/OperatorImpl.hpp"
#include "aidge/operator/OperatorTensor.hpp"
#include "aidge/operator/Operator.hpp"
#include <pybind11/stl.h>

namespace py = pybind11;
namespace Aidge {
void init_OperatorTensor(py::module& m){
    py::class_<OperatorTensor, std::shared_ptr<OperatorTensor>, Operator>(m, "OperatorTensor")
    .def("get_output", &OperatorTensor::getOutput, py::arg("outputIdx"))
    .def("get_input", &OperatorTensor::getInput, py::arg("inputIdx"))
    .def("output_dims_forwarded", &OperatorTensor::outputDimsForwarded)
    ;
}
}
